diff --git a/app/Repositories/User/EloquentUser.php b/app/Repositories/User/EloquentUser.php
index 4372f25..229f8f4 100644
--- a/app/Repositories/User/EloquentUser.php
+++ b/app/Repositories/User/EloquentUser.php
@@ -98,8 +98,7 @@ class EloquentUser implements UserRepository
             });
         }
 
-        $result = $query->orderBy('created_at', 'desc')
-            ->paginate($perPage);
+        $result = $query->paginate($perPage);
 
         if ($search) {
             $result->appends(['search' => $search]);
@@ -113,10 +112,6 @@ class EloquentUser implements UserRepository
      */
     public function update($id, array $data)
     {
-        if (array_get($data, 'country_id') == 0) {
-            $data['country_id'] = null;
-        }
-
         return $this->find($id)->update($data);
     }
 
@@ -189,7 +184,7 @@ class EloquentUser implements UserRepository
             ->whereBetween('created_at', [$from, $to])
             ->groupBy('month')
             ->orderBy('month', 'ASC')
-            ->pluck('count', 'month');
+            ->lists('count', 'month');
 
         $counts = [];
 
@@ -238,9 +233,11 @@ class EloquentUser implements UserRepository
      */
     public function getUserSocialLogins($userId)
     {
-        return DB::table('social_logins')
+        $result = DB::table('social_logins')
             ->where('user_id', $userId)
             ->get();
+
+        return collect($result);
     }
 
     /**
@@ -270,4 +267,4 @@ class EloquentUser implements UserRepository
             ->where('role_id', $fromRoleId)
             ->update(['role_id' => $toRoleId]);
     }
-}
+}
\ No newline at end of file
diff --git a/app/User.php b/app/User.php
index 119b963..c2f050a 100644
--- a/app/User.php
+++ b/app/User.php
@@ -2,21 +2,26 @@
 
 namespace Portal;
 
-use Illuminate\Notifications\Messages\MailMessage;
-use Illuminate\Notifications\Notifiable;
 use Portal\Presenters\UserPresenter;
 use Portal\Services\Auth\TwoFactor\Authenticatable as TwoFactorAuthenticatable;
 use Portal\Services\Auth\TwoFactor\Contracts\Authenticatable as TwoFactorAuthenticatableContract;
 use Portal\Services\Logging\UserActivity\Activity;
 use Portal\Support\Authorization\AuthorizationUserTrait;
 use Portal\Support\Enum\UserStatus;
+use Illuminate\Database\Eloquent\Model;
 use Illuminate\Auth\Passwords\CanResetPassword;
+use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
+use Illuminate\Contracts\Auth\Access\Authorizable as AuthorizableContract;
+use Illuminate\Contracts\Auth\CanResetPassword as CanResetPasswordContract;
 use Laracasts\Presenter\PresentableTrait;
-use Illuminate\Foundation\Auth\User as Authenticatable;
+use Zizaco\Entrust\Traits\EntrustUserTrait;
 
-class User extends Authenticatable implements TwoFactorAuthenticatableContract
+class User extends Model implements AuthenticatableContract,
+                                    AuthorizableContract,
+                                    CanResetPasswordContract,
+                                    TwoFactorAuthenticatableContract
 {
-    use TwoFactorAuthenticatable, CanResetPassword, PresentableTrait, AuthorizationUserTrait, Notifiable;
+    use TwoFactorAuthenticatable, CanResetPassword, PresentableTrait, AuthorizationUserTrait;
 
     protected $presenter = UserPresenter::class;
 
diff --git a/config/app.php b/config/app.php
index 9371dc8..f44deb7 100644
--- a/config/app.php
+++ b/config/app.php
@@ -4,26 +4,10 @@ return [
 
     /*
     |--------------------------------------------------------------------------
-    | Application Name
-    |--------------------------------------------------------------------------
-    |
-    | This value is the name of your application. This value is used when the
-    | framework needs to place the application's name in a notification or
-    | any other location as required by the application or its packages.
-    |
-    | NOTE: This version is overwritten inside app/Providers/AppServiceProvider.php
-    | and it will se application name defined from Portal settings page.
-    |
-    */
-
-    'name' => '',
-
-    /*
-    |--------------------------------------------------------------------------
     | Portal Version
     |--------------------------------------------------------------------------
     */
-    'version' => '1.2.0',
+    'version' => '1.1.2',
 
     /*
     |--------------------------------------------------------------------------
@@ -161,7 +145,6 @@ return [
         Illuminate\Foundation\Providers\FoundationServiceProvider::class,
         Illuminate\Hashing\HashServiceProvider::class,
         Illuminate\Mail\MailServiceProvider::class,
-        Illuminate\Notifications\NotificationServiceProvider::class,
         Illuminate\Pagination\PaginationServiceProvider::class,
         Illuminate\Pipeline\PipelineServiceProvider::class,
         Illuminate\Queue\QueueServiceProvider::class,
@@ -182,7 +165,7 @@ return [
         Portal\Providers\HtmlServiceProvider::class,
         Webpatser\Countries\CountriesServiceProvider::class,
         Intervention\Image\ImageServiceProvider::class,
-        Portal\Providers\EntrustServiceProvider::class,
+        Zizaco\Entrust\EntrustServiceProvider::class,
         anlutro\LaravelSettings\ServiceProvider::class,
 
         /*
@@ -190,7 +173,6 @@ return [
          */
         Portal\Providers\AppServiceProvider::class,
         Portal\Providers\AuthServiceProvider::class,
-        // App\Providers\BroadcastServiceProvider::class,
         Portal\Providers\EventServiceProvider::class,
         Portal\Providers\RouteServiceProvider::class,
         Portal\Services\Auth\TwoFactor\AuthyServiceProvider::class,
@@ -243,7 +225,6 @@ return [
         'URL'       => Illuminate\Support\Facades\URL::class,
         'Validator' => Illuminate\Support\Facades\Validator::class,
         'View'      => Illuminate\Support\Facades\View::class,
-        'Notification' => Illuminate\Support\Facades\Notification::class,
 
         'JsValidator' => Proengsoft\JsValidation\Facades\JsValidatorFacade::class,
         'Socialite' => Laravel\Socialite\Facades\Socialite::class,
@@ -255,7 +236,6 @@ return [
         'Settings' => anlutro\LaravelSettings\Facade::class,
         'Authy' => Portal\Services\Auth\TwoFactor\Facade::class,
 
-
     ],
 
 ];
diff --git a/config/database.php b/config/database.php
index b4e0677..4eac88e 100644
--- a/config/database.php
+++ b/config/database.php
@@ -60,7 +60,6 @@ return [
 
         'mysql' => [
             'driver'    => 'mysql',
-            'engine'    => 'InnoDB',
             'host'      => env('DB_HOST', 'localhost'),
             'database'  => env('DB_DATABASE', 'forge'),
             'username'  => env('DB_USERNAME', 'forge'),
diff --git a/database/factories/ModelFactory.php b/database/factories/ModelFactory.php
index 8afd702..18ed5a1 100644
--- a/database/factories/ModelFactory.php
+++ b/database/factories/ModelFactory.php
@@ -19,7 +19,7 @@ $factory->define(Portal\User::class, function (Faker\Generator $faker, array $
 
     $countryId = isset($attrs['country_id'])
         ? $attrs['country_id']
-        : $faker->randomElement(Country::pluck('id')->toArray());
+        : $faker->randomElement(Country::lists('id')->toArray());
 
     return [
         'email' => $faker->email,
diff --git a/database/migrations/2015_10_10_170827_create_users_table.php b/database/migrations/2015_10_10_170827_create_users_table.php
index 816b1e6..c5ff5f0 100644
--- a/database/migrations/2015_10_10_170827_create_users_table.php
+++ b/database/migrations/2015_10_10_170827_create_users_table.php
@@ -16,7 +16,7 @@ class CreateUsersTable extends Migration
         {
             $table->increments('id');
             $table->string('email')->unique();
-            $table->string('username')->nullable();
+            $table->string('username')->nullable()->unique();
             $table->string('password');
             $table->string('first_name')->nullable();
             $table->string('last_name')->nullable();
diff --git a/extra/auth.php b/extra/auth.php
index 0ddfd1c..be822aa 100644
--- a/extra/auth.php
+++ b/extra/auth.php
@@ -3,12 +3,8 @@
 require __DIR__.'/../bootstrap/autoload.php';
 $app = require_once __DIR__.'/../bootstrap/app.php';
 
-$request = Illuminate\Http\Request::capture();
-
 $kernel = $app->make(Illuminate\Contracts\Http\Kernel::class);
-$kernel->pushMiddleware(\Portal\Http\Middleware\EncryptCookies::class);
-$kernel->pushMiddleware(\Illuminate\Session\Middleware\StartSession::class);
-$kernel->handle($request);
+$kernel->handle(Illuminate\Http\Request::capture());
 
 /**
  * Redirect to provided url
diff --git a/public/assets/js/as/app.js b/public/assets/js/as/app.js
index ff71ef6..ec53e4a 100644
--- a/public/assets/js/as/app.js
+++ b/public/assets/js/as/app.js
@@ -17,12 +17,48 @@ as.hideNotifications = function () {
     })
 };
 
+as.adjustPage = function () {
+    /**
+     * Page top offset, used for setting appropriate top offset
+     * for page content when we are resizing the page (or open it on small screen).
+     * @type {number}
+     */
+    var topOffset = 0;
+
+    // Current width of our viewport.
+    var width = window.innerWidth > 0
+        ? window.innerWidth
+        : screen.width;
+
+    // If width is smaller than 768px, we will adjust page top offset.
+    if (width < 768) {
+        topOffset = 100;
+    }
+
+    // Current viewport height
+    var height = window.innerHeight > 0
+        ? window.innerHeight
+        : screen.height;
+
+    height = height - topOffset;
+
+    if (height < 1) {
+        height = 1;
+    }
+
+    $("#page-wrapper").css("margin-top", (topOffset) + "px");
+
+    if (height > topOffset) {
+        $("#page-wrapper").css("min-height", (height) + "px");
+    }
+};
+
 as.init = function () {
 
-    var sideMenu = $("#side-menu");
+    $(window).bind("load resize", as.adjustPage);
 
-    if (sideMenu.length) {
-        sideMenu.metisMenu({
+    if ($("#side-menu").length) {
+        $("#side-menu").metisMenu({
             toggle: false,
             activeClass: 'active'
         });
diff --git a/public/assets/js/as/dashboard-admin.js b/public/assets/js/as/dashboard-admin.js
index 5d4cb95..791fbab 100644
--- a/public/assets/js/as/dashboard-admin.js
+++ b/public/assets/js/as/dashboard-admin.js
@@ -1,5 +1,16 @@
 as.dashboard = {};
 
+as.dashboard.adjustWidgetsHeight = function () {
+    var maxHeight = 0;
+    $(".panel-widget .panel-heading").height('auto');
+    $(".panel-widget .panel-heading").each(function () {
+        if ($(this).height() > maxHeight) {
+            maxHeight = $(this).height();
+        }
+    });
+    $(".panel-widget .panel-heading").height(maxHeight);
+};
+
 as.dashboard.initChart = function () {
     var data = {
         labels: months,
@@ -26,5 +37,6 @@ as.dashboard.initChart = function () {
 };
 
 $(document).ready(function () {
+    as.dashboard.adjustWidgetsHeight();
     as.dashboard.initChart();
 });
\ No newline at end of file
diff --git a/resources/lang/en/app.php b/resources/lang/en/app.php
index 4bee34e..b83f0bd 100644
--- a/resources/lang/en/app.php
+++ b/resources/lang/en/app.php
@@ -6,7 +6,7 @@ return [
     'active_sessions' => 'Active Sessions',
     'copyright' => 'Copyright',
     'users' => 'Users',
-    'users_sm' => 'users',
+    'users_sm' => 'korisnika',
     'roles_and_permissions' => 'Roles & Permissions',
     'roles' => 'Roles',
     'permissions' => 'Permissions',
@@ -305,22 +305,16 @@ return [
 
     //Emails
     'hi' => 'Hi',
-    'registration_confirmation' => 'Registration Confirmation',
     'new_user_was_registered_on' => 'New user was just registered on :app website.',
     'website' => 'website',
     'to_view_details_visit_link_below' => 'To view user details just visit the link below:',
     'many_thanks' => 'Many Thanks',
-    'request_for_password_reset_made' => 'You are receiving this email because we received a password reset request for your account.',
-    'if_you_did_not_requested' => 'If you did not request a password reset, no further action is required.',
+    'request_for_password_reset_made' => 'A request has been made to reset your password.',
     'click_on_link_below' => 'Please click on this link below in order to reset your password:',
-    'if_you_cant_click' => 'If you’re having trouble clicking the ":button" button, copy and paste the URL below into your web browser:',
+    'if_you_cant_click' => 'If you can\'t click on that link, just copy and paste following url in your browser\'s address bar:',
     'thank_you_for_registering' => 'Thank you for registering on :app website.',
     'confirm_email_on_link_below' => 'Please confirm your email by clicking on the link below:',
     'confirm_email' => 'Confirm Email',
-    'new_user_registration' => 'New User Registration',
-    'thank_you_for_using_our_app' => 'Thank you for using our application.',
-    'all_rights_reserved' => 'All rights reserved.',
-    'regards' => 'Regards',
 
     'months' => [
         'January' => 'January',
diff --git a/resources/views/layouts/app.blade.php b/resources/views/layouts/app.blade.php
index edd1940..0dd4810 100644
--- a/resources/views/layouts/app.blade.php
+++ b/resources/views/layouts/app.blade.php
@@ -10,8 +10,6 @@
 
     <title>@yield('page-title') | {{ settings('app_name') }}</title>
 
-    <link href="https://fonts.googleapis.com/css?family=Roboto:400,300,100,500,700,900" rel="stylesheet" type="text/css">
-
     <link rel="apple-touch-icon-precomposed" sizes="144x144" href="{{ url('assets/img/icons/apple-touch-icon-144x144.png') }}" />
     <link rel="apple-touch-icon-precomposed" sizes="152x152" href="{{ url('assets/img/icons/apple-touch-icon-152x152.png') }}" />
     <link rel="icon" type="image/png" href="{{ url('assets/img/icons/favicon-32x32.png') }}" sizes="32x32" />
@@ -45,7 +43,7 @@
                 <ul class="nav navbar-nav navbar-right">
                     <li class="dropdown">
                         <a href="#" class="dropdown-toggle avatar" data-toggle="dropdown">
-                            <img alt="image" class="img-circle avatar" src="{{ Auth::user()->present()->avatar }}">
+                            <img alt="image" class="img-circle" src="{{ Auth::user()->present()->avatar }}">
                             {{ Auth::user()->present()->name }}
                             <b class="caret"></b>
                         </a>
diff --git a/resources/views/partials/sidebar.blade.php b/resources/views/partials/sidebar.blade.php
index 52e57e7..1052392 100644
--- a/resources/views/partials/sidebar.blade.php
+++ b/resources/views/partials/sidebar.blade.php
@@ -4,7 +4,7 @@
             <li class="sidebar-avatar">
                 <div class="dropdown">
                     <div>
-                        <img alt="image" class="img-circle avatar" width="100" src="{{ Auth::user()->present()->avatar }}">
+                        <img alt="image" class="img-circle" width="100" src="{{ Auth::user()->present()->avatar }}">
                     </div>
                     <div class="name"><strong>{{ Auth::user()->present()->nameOrEmail }}</strong></div>
                 </div>
diff --git a/resources/views/settings/partials/auth.blade.php b/resources/views/settings/partials/auth.blade.php
index 575c85e..4845a6c 100644
--- a/resources/views/settings/partials/auth.blade.php
+++ b/resources/views/settings/partials/auth.blade.php
@@ -37,8 +37,7 @@
                       data-placement="top"
                       title="@lang('app.number_of_minutes')"></span>
             </label>
-            <input type="text" name="login_reset_token_lifetime"
-                   class="form-control" value="{{ settings('login_reset_token_lifetime', 30) }}">
+            <input type="text" name="login_reset_token_lifetime" class="form-control" value="{{ settings('login_reset_token_lifetime', 30) }}">
         </div>
 
         <button type="submit" class="btn btn-primary">
diff --git a/resources/views/user/partials/avatar.blade.php b/resources/views/user/partials/avatar.blade.php
index 46eab63..fd8c26a 100644
--- a/resources/views/user/partials/avatar.blade.php
+++ b/resources/views/user/partials/avatar.blade.php
@@ -8,7 +8,7 @@
         </div>
         <div id="avatar"></div>
         <div>
-            <img class="avatar avatar-preview img-circle" src="{{ $edit ? $user->present()->avatar : url('assets/img/profile.png') }}">
+            <img class="avatar-preview img-circle" src="{{ $edit ? $user->present()->avatar : url('assets/img/profile.png') }}">
             <div id="change-picture" class="btn btn-default btn-block" data-toggle="modal" data-target="#choose-modal">
                 <i class="fa fa-camera"></i>
                 @lang('app.change_photo')
diff --git a/tests/functional/FunctionalTestCase.php b/tests/functional/FunctionalTestCase.php
index 06d01fa..c13adf9 100644
--- a/tests/functional/FunctionalTestCase.php
+++ b/tests/functional/FunctionalTestCase.php
@@ -11,8 +11,6 @@ class FunctionalTestCase extends TestCase
 
     protected $seed = true;
 
-    protected $settingsModified = [];
-
     public function setUp()
     {
         $this->afterApplicationCreated(function () {
@@ -29,37 +27,10 @@ class FunctionalTestCase extends TestCase
             $this->artisan('migrate:rollback');
         });
 
-        $this->beforeApplicationDestroyed(function () {
-            foreach ($this->settingsModified as $key => $value) {
-                Settings::set($key, $value);
-            }
-
-            Settings::save();
-
-            $this->settingsModified = [];
-        });
-
         parent::setUp();
     }
 
     /**
-     * Set some setting that should automatically be
-     * reverted to it's default value after each test.
-     * @param array $settings
-     */
-    protected function setSettings(array $settings)
-    {
-        foreach ($settings as $key => $value) {
-            $this->settingsModified[$key] = settings($key);
-            Settings::set($key, $value);
-        }
-
-        Settings::save();
-
-        $this->refreshAppAndExecuteCallbacks();
-    }
-
-    /**
      * @param array $attrubutes
      * @return mixed
      */
@@ -131,6 +102,24 @@ class FunctionalTestCase extends TestCase
         return $user;
     }
 
+    public function seeElement($element, $negate = false)
+    {
+        $method = $negate ? 'assertEquals' : 'assertGreaterThan';
+
+        $message = $negate
+            ? "Element [$element] exists on specified page."
+            : "Element [$element] does not exist on specified page.";
+
+        $this->$method(0, $this->crawler->filter($element)->count(), $message);
+
+        return $this;
+    }
+
+    public function dontSeeElement($element)
+    {
+        return $this->seeElement($element, true);
+    }
+
     public function seeInTable($selector, $text, $rowNumber, $columnNumber, $negate = false)
     {
         $fullSelector = "{$selector} tbody tr:nth-child({$rowNumber}) > td:nth-child({$columnNumber})";
@@ -153,4 +142,5 @@ class FunctionalTestCase extends TestCase
         $link = $this->crawler->filter($selector)->first();
         return $this->visit($link->link()->getUri());
     }
-}
+
+}
\ No newline at end of file
diff --git a/tests/functional/Http/Controllers/ActivityControllerTest.php b/tests/functional/Http/Controllers/ActivityControllerTest.php
index 27a7b4f..b837c53 100644
--- a/tests/functional/Http/Controllers/ActivityControllerTest.php
+++ b/tests/functional/Http/Controllers/ActivityControllerTest.php
@@ -15,12 +15,11 @@ class ActivityControllerTest extends FunctionalTestCase
     {
         parent::setUp();
         $this->logger = app(Portal\Services\Logging\UserActivity\Logger::class);
+        $this->withoutMiddleware();
     }
 
     public function test_display_all_activities()
     {
-        $this->withoutMiddleware();
-
         $user1 = factory(User::class)->create();
         $user2 = factory(User::class)->create();
 
@@ -41,8 +40,8 @@ class ActivityControllerTest extends FunctionalTestCase
 
     public function test_display_activities_for_user()
     {
-        $user = $this->createAndLoginAdminUser();
-
+        $user = factory(User::class)->create();
+        $this->be($user);
         $this->logger->log('foo');
 
         $this->visit('activity')
@@ -53,8 +52,6 @@ class ActivityControllerTest extends FunctionalTestCase
 
     public function test_search_activities()
     {
-        $this->withoutMiddleware();
-
         $user = factory(User::class)->create();
         $this->be($user);
         $this->logger->log('foo');
diff --git a/tests/functional/Http/Controllers/Auth/AuthControllerTest.php b/tests/functional/Http/Controllers/Auth/AuthControllerTest.php
index 6e8d746..a6cd184 100644
--- a/tests/functional/Http/Controllers/Auth/AuthControllerTest.php
+++ b/tests/functional/Http/Controllers/Auth/AuthControllerTest.php
@@ -113,13 +113,11 @@ class AuthControllerTest extends FunctionalTestCase
 
     public function test_registration_with_email_confirmation()
     {
-        $this->setSettings([
-            'reg_enabled' => true,
-            'reg_email_confirmation' => true
-        ]);
-
         $this->expectsEvents(Registered::class);
 
+        Settings::set('reg_enabled', true);
+        Settings::set('reg_email_confirmation', true);
+
         $data = $this->getRegistrationFormStubData();
 
         $this->registerUser($data);
@@ -138,16 +136,8 @@ class AuthControllerTest extends FunctionalTestCase
         $this->assertEquals('test@test.com', $message['to_email']);
         $this->assertEquals(config('mail.from.address'), $message['from_email']);
         $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            trans('app.confirm_email_on_link_below'),
-            trim($message['html_body'])
-        );
-        $this->assertContains(
-            route('register.confirm-email', $token),
+        $this->assertEquals(
+            view('emails.registration.confirmation', compact('token'))->render(),
             trim($message['html_body'])
         );
 
@@ -156,14 +146,12 @@ class AuthControllerTest extends FunctionalTestCase
 
     public function test_registration_without_email_confirmation()
     {
-        $this->setSettings([
-            'reg_enabled' => true,
-            'reg_email_confirmation' => false,
-            'notifications_signup_email' => false
-        ]);
-
         $this->expectsEvents(Registered::class);
 
+        Settings::set('reg_enabled', true);
+        Settings::set('reg_email_confirmation', false);
+        Settings::set('notifications_signup_email', false);
+
         $data = $this->getRegistrationFormStubData();
         $this->registerUser($data);
 
@@ -179,13 +167,6 @@ class AuthControllerTest extends FunctionalTestCase
 
     public function test_email_notification_when_new_user_was_registered()
     {
-        $this->setSettings([
-            'app_name' => 'foo',
-            'reg_enabled' => true,
-            'reg_email_confirmation' => false,
-            'notifications_signup_email' => true
-        ]);
-
         $admin1 = factory(User::class)->create(['email' => 'john.doe@test.com']);
         $admin2 = factory(User::class)->create(['email' => 'jane.doe@test.com']);
         $user = factory(User::class)->create(['email' => 'user.doe@test.com']);
@@ -196,6 +177,10 @@ class AuthControllerTest extends FunctionalTestCase
         $role = Role::where('name', 'User')->first();
         $role->users()->attach($user->id);
 
+        Settings::set('reg_enabled', true);
+        Settings::set('reg_email_confirmation', false);
+        Settings::set('notifications_signup_email', true);
+
         $data = $this->getRegistrationFormStubData();
         $this->registerUser($data);
 
@@ -205,23 +190,19 @@ class AuthControllerTest extends FunctionalTestCase
 
         $this->assertEquals(2, count($inbox));
 
-        $this->assertEquals('[foo] New User Registration', $inbox[0]['subject']);
+        $this->assertEquals('New User Registration', $inbox[0]['subject']);
         $this->assertEquals('jane.doe@test.com', $inbox[0]['to_email']);
-        $this->assertContains(
-            trans('app.new_user_was_registered_on', ['app' => settings('app_name')]),
-            trim($inbox[0]['html_body'])
-        );
-        $this->assertContains(
-            trans('app.to_view_details_visit_link_below'),
-            trim($inbox[0]['html_body'])
-        );
-        $this->assertContains(
-            route('user.show', $newUser->id),
+        $this->assertEquals(
+            view('emails.notifications.new-registration', ['user' => $admin2, 'newUser' => $newUser])->render(),
             trim($inbox[0]['html_body'])
         );
 
-        $this->assertEquals('[foo] New User Registration', $inbox[1]['subject']);
+        $this->assertEquals('New User Registration', $inbox[1]['subject']);
         $this->assertEquals('john.doe@test.com', $inbox[1]['to_email']);
+        $this->assertEquals(
+            view('emails.notifications.new-registration', ['user' => $admin1, 'newUser' => $newUser])->render(),
+            trim($inbox[1]['html_body'])
+        );
 
         $this->emptyInbox();
     }
@@ -233,7 +214,7 @@ class AuthControllerTest extends FunctionalTestCase
         factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
 
         $this->visit('login' . $to)
-            ->seeElement('input', ['type' => 'hidden', 'name' => 'to'])
+            ->seeElement('input[type=hidden][name=to]')
             ->type('foo', 'username')
             ->type('bar', 'password')
             ->press('Log In');
@@ -244,28 +225,20 @@ class AuthControllerTest extends FunctionalTestCase
     public function test_custom_redirect_page_is_available_after_failed_login_attempt()
     {
         $to = 'http://www.google.com';
-        $element = 'input';
-        $elementAttrs = ['type' => 'hidden', 'name' => 'to'];
+        $element = 'input[type=hidden][name=to]';
 
         $this->visit('login?to=' . $to)
-            ->seeElement($element, $elementAttrs)
+            ->seeElement($element)
             ->type('foo', 'username')
             ->type('bar', 'password')
             ->press('Log In');
 
         $this->seePageIs('login?to=' . urlencode($to))
-            ->seeElement($element, $elementAttrs);
+            ->seeElement($element);
     }
 
     public function test_access_to_auth_pages_is_not_allowed_after_authentication()
     {
-        $this->setSettings([
-            'reg_enabled' => true,
-            '2fa.enabled' => true
-        ]);
-
-        $this->refreshAppAndExecuteCallbacks();
-
         factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
         $this->loginUser('foo', 'bar');
 
@@ -323,7 +296,11 @@ class AuthControllerTest extends FunctionalTestCase
 
     public function test_login_with_2fa_enabled()
     {
-        $this->setSettings(['2fa.enabled' => true]);
+        $currentSetting = Settings::get('2fa.enabled');
+        Settings::set('2fa.enabled', true);
+        Settings::save();
+
+        $this->refreshAppAndExecuteCallbacks();
 
         $this->expectsEvents(LoggedIn::class);
 
@@ -339,11 +316,16 @@ class AuthControllerTest extends FunctionalTestCase
         $this->type('123', 'token')
             ->press('Validate')
             ->seePageIs('/');
+
+        Settings::set('2fa.enabled', $currentSetting);
+        Settings::save();
     }
 
     public function test_login_with_wrong_2fa_token()
     {
-        $this->setSettings(['2fa.enabled' => true]);
+        $currentSetting = Settings::get('2fa.enabled');
+        Settings::set('2fa.enabled', true);
+        Settings::save();
 
         $this->refreshAppAndExecuteCallbacks();
 
@@ -360,27 +342,10 @@ class AuthControllerTest extends FunctionalTestCase
             ->press('Validate')
             ->seePageIs('login')
             ->see('2FA Token is invalid!');
-    }
 
-    /**
-     * Mock the event dispatcher so all events are silenced and collected.
-     * We will override it to allow model events though, since we want
-     * user notifications to be sent, so we can test them.
-     *
-     * @return $this
-     */
-    protected function withoutEvents()
-    {
-        $mock = Mockery::mock('Illuminate\Contracts\Events\Dispatcher');
-
-        $mock->shouldReceive('fire')->andReturnUsing(function ($called) {
-            $this->firedEvents[] = $called;
-        });
-
-        $mock->shouldReceive('until');
+        Settings::set('2fa.enabled', $currentSetting);
+        Settings::save();
+    }
 
-        $this->app->instance('events', $mock);
 
-        return $this;
-    }
 }
diff --git a/tests/functional/Http/Controllers/Auth/PasswordControllerTest.php b/tests/functional/Http/Controllers/Auth/PasswordControllerTest.php
index fb48ffc..6e38637 100644
--- a/tests/functional/Http/Controllers/Auth/PasswordControllerTest.php
+++ b/tests/functional/Http/Controllers/Auth/PasswordControllerTest.php
@@ -29,19 +29,9 @@ class PasswordControllerTest extends FunctionalTestCase
         $this->assertEquals('test@test.com', $message['to_email']);
         $this->assertEquals(config('mail.from.address'), $message['from_email']);
         $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.request_for_password_reset_made'),
-            $message['html_body']
-        );
-
-        $this->assertContains(
-            url("password/reset/{$token}"),
-            $message['html_body']
-        );
-
-        $this->assertContains(
-            trans('app.if_you_did_not_requested'),
-            $message['html_body']
+        $this->assertEquals(
+            view('emails.password.remind', compact('token'))->render(),
+            trim($message['html_body'])
         );
 
         $this->emptyInbox();
@@ -126,26 +116,4 @@ class PasswordControllerTest extends FunctionalTestCase
             ->type('123123', 'password_confirmation')
             ->press('Update Password');
     }
-
-    /**
-     * Mock the event dispatcher so all events are silenced and collected.
-     * We will override it to allow model events though, since we want
-     * user notifications to be sent, so we can test them.
-     *
-     * @return $this
-     */
-    protected function withoutEvents()
-    {
-        $mock = Mockery::mock('Illuminate\Contracts\Events\Dispatcher');
-
-        $mock->shouldReceive('fire')->andReturnUsing(function ($called) {
-            $this->firedEvents[] = $called;
-        });
-
-        $mock->shouldReceive('until');
-
-        $this->app->instance('events', $mock);
-
-        return $this;
-    }
 }
